Index: squid/src/structs.h
diff -u squid/src/structs.h:1.26 squid/src/structs.h:1.2.2.20
--- squid/src/structs.h:1.26	Tue Feb 20 16:10:13 2001
+++ squid/src/structs.h	Sun Mar 18 14:33:32 2001
@@ -981,8 +981,6 @@
 struct _clientHttpRequest {
     ConnStateData *conn;
     request_t *request;		/* Parsed URL ... */
-    store_client *sc;		/* The store_client we're using */
-    store_client *old_sc;	/* ... for entry to be validated */
     char *uri;
     char *log_uri;
     struct {
@@ -1013,6 +1011,8 @@
 	char *location;
     } redirect;
     dlink_node active;
+    char *buf;			/* transient buffer... eeeew! */
+    int bufofs;			/* offset in the current buffer .. */
 };
 
 struct _ConnStateData {
@@ -1090,8 +1090,6 @@
     PeerDigest *pd;
     StoreEntry *entry;
     StoreEntry *old_entry;
-    store_client *sc;
-    store_client *old_sc;
     request_t *request;
     int offset;
     int mask_offset;
@@ -1348,6 +1346,7 @@
 
 /* keep track each client receiving data from that particular StoreEntry */
 struct _store_client {
+    int valid;
     int type;
     off_t copy_offset;
     off_t seen_offset;
@@ -1406,16 +1405,6 @@
 struct _MemObject {
     method_t method;
     char *url;
-    mem_hdr data_hdr;
-    off_t inmem_hi;
-    off_t inmem_lo;
-    dlink_list clients;
-    int nclients;
-    struct {
-	off_t queue_offset;	/* relative to in-mem data */
-	mem_node *memnode;	/* which node we're currently paging out */
-	storeIOState *sio;
-    } swapout;
     HttpReply *reply;
     request_t *request;
     struct timeval start_ping;
@@ -1438,6 +1427,7 @@
 
 struct _StoreEntry {
     hash_link hash;		/* must be first */
+    dlink_node node;		/* to track current objects .. */
     MemObject *mem_obj;
     RemovalPolicyNode repl;
     time_t timestamp;
@@ -1454,6 +1444,21 @@
     ping_status_t ping_status:3;
     store_status_t store_status:3;
     swap_status_t swap_status:3;
+
+    /* The request callback information */
+    store_client sc;
+
+    /* The reply callback functions */
+    STRAPPEND *stappend;
+    STRFLUSH *stflush;
+    STRMEMHI *stmemhi;
+    STRMEMLO *stmemlo;
+    STRCLIENTCOPY *stclientcopy;
+    STRPRIVATE *stmakeprivate;
+    STRPUBLIC *stmakepublic;
+    STRDONE *stdone;
+    STRRELEASE *strelease;
+    void *stdata;
 };
 
 struct _SwapDir {
@@ -1486,8 +1491,8 @@
     STCALLBACK *callback;	/* Handle pending callbacks */
     STSYNC *sync;		/* Sync the directory */
     struct {
-	STOBJCREATE *create;
-	STOBJOPEN *open;
+        STOBJCREATE *create;
+        STOBJGET *get;
 	STOBJCLOSE *close;
 	STOBJREAD *read;
 	STOBJWRITE *write;
@@ -1570,7 +1575,6 @@
     int link_count;		/* free when zero */
     request_flags flags;
     HttpHdrCc *cache_control;
-    HttpHdrRange *range;
     http_version_t http_ver;
     time_t ims;
     int imslen;
Index: squid/src/tools.c
diff -u squid/src/tools.c:1.11 squid/src/tools.c:1.2.2.7
--- squid/src/tools.c:1.11	Thu Feb 15 13:09:17 2001
+++ squid/src/tools.c	Tue Feb 20 07:39:42 2001
@@ -348,11 +348,11 @@
 fatal(const char *message)
 {
     releaseServerSockets();
-    /* check for store_dirs_rebuilding because fatal() is often
-     * used in early initialization phases, long before we ever
-     * get to the store log. */
-    if (0 == store_dirs_rebuilding)
-	storeDirWriteCleanLogs(0);
+    /*
+     * Attempt to write clean store log information. If any of the filestores
+     * are rebuilding, they will fail in their own time.
+     */
+    storeDirWriteCleanLogs(0);
     fatal_common(message);
     exit(shutting_down ? 0 : 1);
 }
Index: squid/src/typedefs.h
diff -u squid/src/typedefs.h:1.17 squid/src/typedefs.h:1.2.2.13
--- squid/src/typedefs.h:1.17	Wed Feb 28 20:04:19 2001
+++ squid/src/typedefs.h	Sun Mar 18 14:33:32 2001
@@ -263,13 +263,19 @@
 typedef int STCALLBACK(SwapDir *);
 typedef void STSYNC(SwapDir *);
 
-typedef storeIOState *STOBJCREATE(SwapDir *, StoreEntry *, STFNCB *, STIOCB *, void *);
-typedef storeIOState *STOBJOPEN(SwapDir *, StoreEntry *, STFNCB *, STIOCB *, void *);
+/* store lookup callback */
+typedef void STGETDONE(void *, StoreEntry *);
+
+/* store IO functions */
+typedef storeIOState *STOBJCREATE(SwapDir *, StoreEntry *, STFNCB *, STIOCB *,
+  void *);
 typedef void STOBJCLOSE(SwapDir *, storeIOState *);
 typedef void STOBJREAD(SwapDir *, storeIOState *, char *, size_t, off_t, STRCB *, void *);
 typedef void STOBJWRITE(SwapDir *, storeIOState *, char *, size_t, off_t, FREE *);
 typedef void STOBJUNLINK(SwapDir *, StoreEntry *);
 
+typedef void STOBJGET(SwapDir *, request_t *, STGETDONE *, void *);
+
 typedef void STLOGOPEN(SwapDir *);
 typedef void STLOGCLOSE(SwapDir *);
 typedef void STLOGWRITE(const SwapDir *, const StoreEntry *, int);
@@ -285,6 +291,18 @@
 typedef void STFSSTARTUP(void);
 typedef void STFSSHUTDOWN(void);
 
+/* store reply routines */
+typedef void STRAPPEND(StoreEntry *, const char *, int);
+typedef void STRFLUSH(StoreEntry *);
+typedef off_t STRMEMHI(const StoreEntry *);
+typedef off_t STRMEMLO(const StoreEntry *);
+typedef void STRCLIENTCOPY(StoreEntry *);
+typedef void STRRELEASE(StoreEntry *);
+typedef void STRDONE(StoreEntry *);
+typedef void STRPUBLIC(StoreEntry *);
+typedef void STRPRIVATE(StoreEntry *);
+
+
 typedef double hbase_f(double);
 typedef void StatHistBinDumper(StoreEntry *, int idx, double val, double size, int count);
 
Index: squid/src/urn.c
diff -u squid/src/urn.c:1.10 squid/src/urn.c:1.2.2.9
--- squid/src/urn.c:1.10	Sat Mar  3 02:44:32 2001
+++ squid/src/urn.c	Sun Mar 18 14:33:32 2001
@@ -137,16 +137,17 @@
     }
     httpHeaderPutStr(&urlres_r->header, HDR_ACCEPT, "text/plain");
     if ((urlres_e = storeGetPublic(urlres, METHOD_GET)) == NULL) {
-	urlres_e = storeCreateEntry(urlres, urlres, null_request_flags, METHOD_GET);
-	urnState->sc = storeClientListAdd(urlres_e, urnState);
+	urlres_e = storeCreateEntry(urlres, urlres, null_request_flags,
+          METHOD_GET, REPLY_OBJ_INTERNAL);
+	storeClientRegister(urlres_e, urnState);
 	fwdStart(-1, urlres_e, urlres_r);
     } else {
 	storeLockObject(urlres_e);
-	urnState->sc = storeClientListAdd(urlres_e, urnState);
+	storeClientRegister(urlres_e, urnState);
     }
     urnState->urlres_e = urlres_e;
     urnState->urlres_r = requestLink(urlres_r);
-    storeClientCopy(urnState->sc, urlres_e,
+    storeClientCopy(urlres_e,
 	0,
 	0,
 	4096,
@@ -201,7 +202,7 @@
 	return;
     }
     if (urlres_e->store_status == STORE_PENDING && size < SM_PAGE_SIZE) {
-	storeClientCopy(urnState->sc, urlres_e,
+	storeClientCopy(urlres_e,
 	    size,
 	    0,
 	    SM_PAGE_SIZE,
@@ -292,7 +293,7 @@
     }
     safe_free(urls);
     /* mb was absorbed in httpBodySet call, so we must not clean it */
-    storeUnregister(urnState->sc, urlres_e, urnState);
+    storeClientUnregister(urlres_e, urnState);
     storeUnlockObject(urlres_e);
     storeUnlockObject(urnState->entry);
     requestUnlink(urnState->request);
Index: squid/src/wais.c
diff -u squid/src/wais.c:1.6 squid/src/wais.c:1.2.2.4
--- squid/src/wais.c:1.6	Sat Mar  3 02:44:32 2001
+++ squid/src/wais.c	Sun Mar 18 14:33:32 2001
@@ -70,7 +70,7 @@
     StoreEntry *entry = waisState->entry;
     debug(24, 4) ("waisTimeout: FD %d: '%s'\n", fd, storeUrl(entry));
     if (entry->store_status == STORE_PENDING) {
-	if (entry->mem_obj->inmem_hi == 0) {
+	if (storeMemHiOffset(entry) == 0) {
 	    fwdFail(waisState->fwd,
 		errorCon(ERR_READ_TIMEOUT, HTTP_GATEWAY_TIMEOUT));
 	}
@@ -138,7 +138,7 @@
 	    errorAppendEntry(entry, err);
 	    comm_close(fd);
 	}
-    } else if (len == 0 && entry->mem_obj->inmem_hi == 0) {
+    } else if (len == 0 && storeMemHiOffset(entry) == 0) {
 	ErrorState *err;
 	err = errorCon(ERR_ZERO_SIZE_OBJECT, HTTP_SERVICE_UNAVAILABLE);
 	err->xerrno = errno;
Index: squid/src/whois.c
diff -u squid/src/whois.c:1.6 squid/src/whois.c:1.2.2.6
--- squid/src/whois.c:1.6	Sat Mar  3 02:44:32 2001
+++ squid/src/whois.c	Sun Mar 18 14:33:32 2001
@@ -97,7 +97,7 @@
     debug(75, 3) ("whoisReadReply: FD %d read %d bytes\n", fd, len);
     debug(75, 5) ("{%s}\n", buf);
     if (len > 0) {
-	if (0 == mem->inmem_hi)
+	if (0 == storeMemHiOffset(entry))
 	    mem->reply->sline.status = HTTP_OK;
 	fd_bytes(fd, len, FD_READ);
 	kb_incr(&statCounter.server.all.kbytes_in, len);
@@ -109,7 +109,7 @@
 	    fd, xstrerror());
 	if (ignoreErrno(errno)) {
 	    commSetSelect(fd, COMM_SELECT_READ, whoisReadReply, p, Config.Timeout.read);
-	} else if (mem->inmem_hi == 0) {
+	} else if (storeMemHiOffset(entry) == 0) {
 	    ErrorState *err;
 	    err = errorCon(ERR_READ_ERROR, HTTP_INTERNAL_SERVER_ERROR);
 	    err->xerrno = errno;
Index: squid/src/fs/hash/store_dir_hash.c
diff -u /dev/null squid/src/fs/hash/store_dir_hash.c:1.1.2.5
--- /dev/null	Sun Jan 25 06:37:04 2004
+++ squid/src/fs/hash/store_dir_hash.c	Wed Jan 10 12:41:14 2001
@@ -0,0 +1,621 @@
+
+/*
+ * $Id: squid-modio-HEAD,v 1.1 2004/08/17 20:55:12 hno Exp $
+ *
+ * DEBUG: section 47    Store Directory Routines
+ * AUTHOR: Duane Wessels
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by the
+ *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
+ *  Duane Wessels and the University of California San Diego.  Please
+ *  see the COPYRIGHT file for full details.  Squid incorporates
+ *  software developed and/or copyrighted by other sources.  Please see
+ *  the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+#if HAVE_STATVFS
+#if HAVE_SYS_STATVFS_H
+#include <sys/statvfs.h>
+#endif
+#endif
+
+#include "store_hash.h"
+
+#define DefaultLevelOneDirs     16
+#define DefaultLevelTwoDirs     256
+#define STORE_META_BHASHZ 4096
+
+static int n_hash_dirs = 0;
+static int *hash_dir_index = NULL;
+MemPool *hash_state_pool = NULL;
+static int hash_initialised = 0;
+
+static int storeHashDirCreateDirectory(const char *path, int);
+static int storeHashDirVerifyDirectory(const char *path);
+static char *storeHashDirSwapLogFile(SwapDir *, const char *);
+static STLOGOPEN storeHashDirOpenSwapLog;
+static STINIT storeHashDirInit;
+static STFREE storeHashDirFree;
+static STNEWFS storeHashDirNewfs;
+static STDUMP storeHashDirDump;
+static STMAINTAINFS storeHashDirMaintain;
+static STCHECKOBJ storeHashDirCheckObj;
+static STREFOBJ storeHashDirRefObj;
+static STUNREFOBJ storeHashDirUnrefObj;
+static EVH storeHashDirCleanEvent;
+static EVH storeHashDirRebuildEvent;
+static int storeHashCleanupDoubleCheck(SwapDir *, StoreEntry *);
+static void storeHashDirStats(SwapDir *, StoreEntry *);
+static void storeHashDirInitBitmap(SwapDir *);
+
+/*
+ * These functions were ripped straight out of the heart of store_dir.c.
+ * They assume that the given filenum is on a hash partiton, which may or
+ * may not be true.. 
+ * XXX this evilness should be tidied up at a later date!
+ */
+
+int
+storeHashDirMapBitTest(SwapDir * SD, int fn)
+{
+    sfileno filn = fn;
+    hashinfo_t *hashinfo;
+    hashinfo = (hashinfo_t *) SD->fsdata;
+    return file_map_bit_test(hashinfo->map, filn);
+}
+
+void
+storeHashDirMapBitSet(SwapDir * SD, int fn)
+{
+    sfileno filn = fn;
+    hashinfo_t *hashinfo;
+    hashinfo = (hashinfo_t *) SD->fsdata;
+    file_map_bit_set(hashinfo->map, filn);
+}
+
+void
+storeHashDirMapBitReset(SwapDir * SD, int fn)
+{
+    sfileno filn = fn;
+    hashinfo_t *hashinfo;
+    hashinfo = (hashinfo_t *) SD->fsdata;
+    /*
+     * We have to test the bit before calling file_map_bit_reset.
+     * file_map_bit_reset doesn't do bounds checking.  It assumes
+     * filn is a valid file number, but it might not be because
+     * the map is dynamic in size.  Also clearing an already clear
+     * bit puts the map counter of-of-whack.
+     */
+    if (file_map_bit_test(hashinfo->map, filn))
+	file_map_bit_reset(hashinfo->map, filn);
+}
+
+int
+storeHashDirMapBitAllocate(SwapDir * SD)
+{
+    hashinfo_t *hashinfo = (hashinfo_t *) SD->fsdata;
+    int fn;
+    fn = file_map_allocate(hashinfo->map, hashinfo->suggest);
+    file_map_bit_set(hashinfo->map, fn);
+    hashinfo->suggest = fn + 1;
+    return fn;
+}
+
+/*
+ * Initialise the hash bitmap
+ *
+ * If there already is a bitmap, and the numobjects is larger than currently
+ * configured, we allocate a new bitmap and 'grow' the old one into it.
+ */
+static void
+storeHashDirInitBitmap(SwapDir * sd)
+{
+    hashinfo_t *hashinfo = (hashinfo_t *) sd->fsdata;
+
+    if (hashinfo->map == NULL) {
+	/* First time */
+	hashinfo->map = file_map_create();
+    } else if (hashinfo->map->max_n_files) {
+	/* it grew, need to expand */
+	/* XXX We don't need it anymore .. */
+    }
+    /* else it shrunk, and we leave the old one in place */
+}
+
+static int
+storeHashDirCreateDirectory(const char *path, int should_exist)
+{
+    int created = 0;
+    struct stat st;
+    getCurrentTime();
+    if (0 == stat(path, &st)) {
+	if (S_ISDIR(st.st_mode)) {
+	    debug(20, should_exist ? 3 : 1) ("%s exists\n", path);
+	} else {
+	    fatalf("Swap directory %s is not a directory.", path);
+	}
+    } else if (0 == mkdir(path, 0755)) {
+	debug(20, should_exist ? 1 : 3) ("%s created\n", path);
+	created = 1;
+    } else {
+	fatalf("Failed to make swap directory %s: %s",
+	    path, xstrerror());
+    }
+    return created;
+}
+
+static int
+storeHashDirVerifyDirectory(const char *path)
+{
+    struct stat sb;
+    if (stat(path, &sb) < 0) {
+	debug(20, 0) ("%s: %s\n", path, xstrerror());
+	return -1;
+    }
+    if (S_ISDIR(sb.st_mode) == 0) {
+	debug(20, 0) ("%s is not a directory\n", path);
+	return -1;
+    }
+    return 0;
+}
+
+static char *
+storeHashDirSwapLogFile(SwapDir * sd, const char *ext)
+{
+    LOCAL_ARRAY(char, path, SQUID_MAXPATHLEN);
+    LOCAL_ARRAY(char, pathtmp, SQUID_MAXPATHLEN);
+    LOCAL_ARRAY(char, digit, 32);
+    char *pathtmp2;
+    if (Config.Log.swap) {
+	xstrncpy(pathtmp, sd->path, SQUID_MAXPATHLEN - 64);
+	while (index(pathtmp, '/'))
+	    *index(pathtmp, '/') = '.';
+	while (strlen(pathtmp) && pathtmp[strlen(pathtmp) - 1] == '.')
+	    pathtmp[strlen(pathtmp) - 1] = '\0';
+	for (pathtmp2 = pathtmp; *pathtmp2 == '.'; pathtmp2++);
+	snprintf(path, SQUID_MAXPATHLEN - 64, Config.Log.swap, pathtmp2);
+	if (strncmp(path, Config.Log.swap, SQUID_MAXPATHLEN - 64) == 0) {
+	    strcat(path, ".");
+	    snprintf(digit, 32, "%02d", sd->index);
+	    strncat(path, digit, 3);
+	}
+    } else {
+	xstrncpy(path, sd->path, SQUID_MAXPATHLEN - 64);
+	strcat(path, "/swap.state");
+    }
+    if (ext)
+	strncat(path, ext, 16);
+    return path;
+}
+
+static void
+storeHashDirOpenSwapLog(SwapDir * sd)
+{
+    hashinfo_t *hashinfo = (hashinfo_t *) sd->fsdata;
+    char *path;
+    int fd;
+    path = storeHashDirSwapLogFile(sd, NULL);
+    fd = file_open(path, O_WRONLY | O_CREAT);
+    if (fd < 0) {
+	debug(50, 1) ("%s: %s\n", path, xstrerror());
+	fatal("storeHashDirOpenSwapLog: Failed to open swap log.");
+    }
+    debug(47, 3) ("Cache Dir #%d log opened on FD %d\n", sd->index, fd);
+    hashinfo->swaplog_fd = fd;
+    if (0 == n_hash_dirs)
+	assert(NULL == hash_dir_index);
+    n_hash_dirs++;
+    assert(n_hash_dirs <= Config.cacheSwap.n_configured);
+}
+
+static void
+storeHashDirInit(SwapDir * sd)
+{
+    static int started_clean_event = 0;
+    storeHashDirInitBitmap(sd);
+    storeHashDirOpenSwapLog(sd);
+    if (!started_clean_event) {
+	eventAdd("storeHashDirClean", storeHashDirCleanEvent, NULL, 15.0, 1);
+        /* we can't call the rebuild completion routine until the next loop */
+        eventAdd("storeHashRebuild", storeHashDirRebuildEvent, NULL, 0.0, 1);
+	started_clean_event = 1;
+    }
+}
+
+
+struct _clean_state {
+    char *cur;
+    char *new;
+    char *cln;
+    char *outbuf;
+    off_t outbuf_offset;
+    int fd;
+    RemovalPolicyWalker *walker;
+};
+
+static void
+storeHashDirNewfs(SwapDir * sd)
+{
+    debug(47, 3) ("Creating swap space in %s\n", sd->path);
+    storeHashDirCreateDirectory(sd->path, 0);
+}
+
+static void
+storeHashDirCleanEvent(void *unused)
+{
+    /* Empty for now */
+#if 0
+    eventAdd("storeDirClean", storeHashDirCleanEvent, NULL,
+	15.0 * exp(-0.25 * n), 1);
+#endif
+}
+
+static void
+storeHashDirRebuildEvent(void *data)
+{
+    SwapDir *sd = data;
+
+    struct _store_rebuild_data sr;
+
+    /* feed it an empty rebuild, cause we're empty! */
+    bzero(&sr, sizeof(struct _store_rebuild_data));
+    storeRebuildComplete(&sr);
+}
+
+void
+storeHashDirMaintain(SwapDir * SD)
+{
+    /* Do nothing for now */
+    return;
+}
+
+/*
+ * storeHashDirCheckObj
+ *
+ * This routine is called by storeDirSelectSwapDir to see if the given
+ * object is able to be stored on this filesystem. HASH filesystems will
+ * happily store anything as long as the LRU time isn't too small.
+ */
+int
+storeHashDirCheckObj(SwapDir * SD, const StoreEntry * e)
+{
+#if OLD_UNUSED_CODE
+    if (storeHashDirExpiredReferenceAge(SD) < 300) {
+	debug(20, 3) ("storeHashDirCheckObj: NO: LRU Age = %d\n",
+	    storeHashDirExpiredReferenceAge(SD));
+	/* store_check_cachable_hist.no.lru_age_too_low++; */
+	return -1;
+    }
+#endif
+    /* Return 999 (99.9%) constant load */
+    return 999;
+}
+
+/*
+ * storeHashDirRefObj
+ *
+ * This routine is called whenever an object is referenced, so we can
+ * maintain replacement information within the storage fs.
+ */
+void
+storeHashDirRefObj(SwapDir * SD, StoreEntry * e)
+{
+    debug(1, 3) ("storeHashDirRefObj: referencing %p %d/%d\n", e, e->swap_dirn,
+	e->swap_filen);
+    if (SD->repl->Referenced)
+	SD->repl->Referenced(SD->repl, e, &e->repl);
+}
+
+/*
+ * storeHashDirUnrefObj
+ * This routine is called whenever the last reference to an object is
+ * removed, to maintain replacement information within the storage fs.
+ */
+void
+storeHashDirUnrefObj(SwapDir * SD, StoreEntry * e)
+{
+    debug(1, 3) ("storeHashDirUnrefObj: referencing %p %d/%d\n", e, e->swap_dirn,
+	e->swap_filen);
+    if (SD->repl->Dereferenced)
+	SD->repl->Dereferenced(SD->repl, e, &e->repl);
+}
+
+/*
+ * storeHashDirUnlinkFile
+ *
+ * This routine unlinks a file and pulls it out of the bitmap.
+ * It used to be in storeHashUnlink(), however an interface change
+ * forced this bit of code here. Eeek.
+ */
+void
+storeHashDirUnlinkFile(SwapDir * SD, sfileno f)
+{
+    debug(79, 3) ("storeHashDirUnlinkFile: unlinking fileno %08X\n", f);
+    /* storeHashDirMapBitReset(SD, f); */
+#if 0
+    unlinkdUnlink(storeHashDirFullPath(SD, f, NULL));
+#endif
+}
+
+/*
+ * Add and remove the given StoreEntry from the replacement policy in
+ * use.
+ */
+
+void
+storeHashDirReplAdd(SwapDir * SD, StoreEntry * e)
+{
+    debug(20, 4) ("storeHashDirReplAdd: added node %p to dir %d\n", e,
+	SD->index);
+    SD->repl->Add(SD->repl, e, &e->repl);
+}
+
+
+void
+storeHashDirReplRemove(StoreEntry * e)
+{
+    SwapDir *SD = INDEXSD(e->swap_dirn);
+    debug(20, 4) ("storeHashDirReplRemove: remove node %p from dir %d\n", e,
+	SD->index);
+    SD->repl->Remove(SD->repl, e, &e->repl);
+}
+
+
+
+/* ========== LOCAL FUNCTIONS ABOVE, GLOBAL FUNCTIONS BELOW ========== */
+
+void
+storeHashDirStats(SwapDir * SD, StoreEntry * sentry)
+{
+    hashinfo_t *hashinfo;
+#if HAVE_STATVFS
+    struct statvfs sfs;
+#endif
+    hashinfo = (hashinfo_t *) SD->fsdata;
+    storeAppendPrintf(sentry, "Maximum Size: %d KB\n", SD->max_size);
+    storeAppendPrintf(sentry, "Current Size: %d KB\n", SD->cur_size);
+    storeAppendPrintf(sentry, "Percent Used: %0.2f%%\n",
+	100.0 * SD->cur_size / SD->max_size);
+    storeAppendPrintf(sentry, "Filemap bits in use: %d of %d (%d%%)\n",
+	hashinfo->map->n_files_in_map, hashinfo->map->max_n_files,
+	percent(hashinfo->map->n_files_in_map, hashinfo->map->max_n_files));
+#if HAVE_STATVFS
+#define fsbtoblk(num, fsbs, bs) \
+    (((fsbs) != 0 && (fsbs) < (bs)) ? \
+            (num) / ((bs) / (fsbs)) : (num) * ((fsbs) / (bs)))
+    if (!statvfs(SD->path, &sfs)) {
+	storeAppendPrintf(sentry, "Filesystem Space in use: %d/%d KB (%d%%)\n",
+	    fsbtoblk((sfs.f_blocks - sfs.f_bfree), sfs.f_frsize, 1024),
+	    fsbtoblk(sfs.f_blocks, sfs.f_frsize, 1024),
+	    percent(sfs.f_blocks - sfs.f_bfree, sfs.f_blocks));
+	storeAppendPrintf(sentry, "Filesystem Inodes in use: %d/%d (%d%%)\n",
+	    sfs.f_files - sfs.f_ffree, sfs.f_files,
+	    percent(sfs.f_files - sfs.f_ffree, sfs.f_files));
+    }
+#endif
+    storeAppendPrintf(sentry, "Flags:");
+    if (SD->flags.selected)
+	storeAppendPrintf(sentry, " SELECTED");
+    if (SD->flags.read_only)
+	storeAppendPrintf(sentry, " READ-ONLY");
+    storeAppendPrintf(sentry, "\n");
+#if OLD_UNUSED_CODE
+#if !HEAP_REPLACEMENT
+    storeAppendPrintf(sentry, "LRU Expiration Age: %6.2f days\n",
+	(double) storeHashDirExpiredReferenceAge(SD) / 86400.0);
+#else
+    storeAppendPrintf(sentry, "Storage Replacement Threshold:\t%f\n",
+	heap_peepminkey(sd.repl.heap.heap));
+#endif
+#endif /* OLD_UNUSED_CODE */
+}
+
+/*
+ * storeHashDirReconfigure
+ *
+ * This routine is called when the given swapdir needs reconfiguring 
+ */
+void
+storeHashDirReconfigure(SwapDir * sd, int index, char *path)
+{
+    char *token;
+    int i;
+    int size;
+    int l1;
+    int l2;
+    unsigned int read_only = 0;
+
+    i = GetInteger();
+    size = i << 10;		/* Mbytes to kbytes */
+    if (size <= 0)
+	fatal("storeHashDirReconfigure: invalid size value");
+    i = GetInteger();
+    l1 = i;
+    if (l1 <= 0)
+	fatal("storeHashDirReconfigure: invalid level 1 directories value");
+    i = GetInteger();
+    l2 = i;
+    if (l2 <= 0)
+	fatal("storeHashDirReconfigure: invalid level 2 directories value");
+    if ((token = strtok(NULL, w_space)))
+	if (!strcasecmp(token, "read-only"))
+	    read_only = 1;
+
+    /* just reconfigure it */
+    if (size == sd->max_size)
+	debug(3, 1) ("Cache dir '%s' size remains unchanged at %d KB\n",
+	    path, size);
+    else
+	debug(3, 1) ("Cache dir '%s' size changed to %d KB\n",
+	    path, size);
+    sd->max_size = size;
+    if (sd->flags.read_only != read_only)
+	debug(3, 1) ("Cache dir '%s' now %s\n",
+	    path, read_only ? "Read-Only" : "Read-Write");
+    sd->flags.read_only = read_only;
+    return;
+}
+
+void
+storeHashDirDump(StoreEntry * entry, const char *name, SwapDir * s)
+{
+    storeAppendPrintf(entry, "%s %s %s %d\n",
+	name,
+	"hash",
+	s->path,
+	s->max_size >> 10);
+}
+
+/*
+ * Only "free" the filesystem specific stuff here
+ */
+static void
+storeHashDirFree(SwapDir * s)
+{
+    hashinfo_t *hashinfo = (hashinfo_t *) s->fsdata;
+    if (hashinfo->swaplog_fd > -1) {
+	file_close(hashinfo->swaplog_fd);
+	hashinfo->swaplog_fd = -1;
+    }
+    filemapFreeMemory(hashinfo->map);
+    xfree(hashinfo);
+    s->fsdata = NULL;		/* Will aid debugging... */
+
+}
+
+/*
+ * storeHashCleanupDoubleCheck
+ *
+ * This is called by storeCleanup() if -S was given on the command line.
+ */
+static int
+storeHashCleanupDoubleCheck(SwapDir * sd, StoreEntry * e)
+{
+    struct stat sb;
+#if 0
+    if (stat(storeHashDirFullPath(sd, e->swap_filen, NULL), &sb) < 0) {
+	debug(20, 0) ("storeHashCleanupDoubleCheck: MISSING SWAP FILE\n");
+	debug(20, 0) ("storeHashCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
+	debug(20, 0) ("storeHashCleanupDoubleCheck: PATH %s\n",
+	    storeHashDirFullPath(sd, e->swap_filen, NULL));
+	storeEntryDump(e, 0);
+	return -1;
+    }
+    if (e->swap_file_sz != sb.st_size) {
+	debug(20, 0) ("storeHashCleanupDoubleCheck: SIZE MISMATCH\n");
+	debug(20, 0) ("storeHashCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
+	debug(20, 0) ("storeHashCleanupDoubleCheck: PATH %s\n",
+	    storeHashDirFullPath(sd, e->swap_filen, NULL));
+	debug(20, 0) ("storeHashCleanupDoubleCheck: ENTRY SIZE: %d, FILE SIZE: %d\n",
+	    e->swap_file_sz, (int) sb.st_size);
+	storeEntryDump(e, 0);
+	return -1;
+    }
+#endif
+    return 0;
+}
+
+/*
+ * storeHashDirParse
+ *
+ * Called when a *new* fs is being setup.
+ */
+void
+storeHashDirParse(SwapDir * sd, int index, char *path)
+{
+    char *token;
+    int i;
+    int size;
+    unsigned int read_only = 0;
+    hashinfo_t *hashinfo;
+
+    i = GetInteger();
+    size = i << 10;		/* Mbytes to kbytes */
+    if (size <= 0)
+	fatal("storeHashDirParse: invalid size value");
+    if ((token = strtok(NULL, w_space)))
+	if (!strcasecmp(token, "read-only"))
+	    read_only = 1;
+
+    hashinfo = xmalloc(sizeof(hashinfo_t));
+    if (hashinfo == NULL)
+	fatal("storeHashDirParse: couldn't xmalloc() hashinfo_t!\n");
+
+    sd->index = index;
+    sd->path = xstrdup(path);
+    sd->max_size = size;
+    sd->fsdata = hashinfo;
+    hashinfo->swaplog_fd = -1;
+    hashinfo->map = NULL;	/* Debugging purposes */
+    hashinfo->suggest = 0;
+    sd->flags.read_only = read_only;
+    sd->init = storeHashDirInit;
+    sd->newfs = storeHashDirNewfs;
+    sd->dump = storeHashDirDump;
+    sd->freefs = storeHashDirFree;
+    sd->dblcheck = storeHashCleanupDoubleCheck;
+    sd->statfs = storeHashDirStats;
+    sd->maintainfs = storeHashDirMaintain;
+    sd->checkobj = storeHashDirCheckObj;
+    sd->refobj = storeHashDirRefObj;
+    sd->unrefobj = storeHashDirUnrefObj;
+    sd->callback = NULL;
+    sd->sync = NULL;
+
+    sd->obj.get = storeHashGet;
+    sd->obj.close = storeHashClose;
+    sd->obj.read = storeHashRead;
+    sd->obj.write = storeHashWrite;
+    sd->obj.unlink = storeHashUnlink;
+    sd->log.open = NULL;
+    sd->log.close = NULL;
+    sd->log.write = NULL;
+    sd->log.clean.start = NULL;
+    sd->log.clean.nextentry = NULL;
+    sd->log.clean.done = NULL;
+
+    /* Initialise replacement policy stuff */
+    sd->repl = createRemovalPolicy(Config.replPolicy);
+}
+
+/*
+ * Initial setup / end destruction
+ */
+void
+storeHashDirDone(void)
+{
+    memPoolDestroy(hash_state_pool);
+    hash_initialised = 0;
+}
+
+void
+storeFsSetup_hash(storefs_entry_t * storefs)
+{
+    assert(!hash_initialised);
+    storefs->parsefunc = storeHashDirParse;
+    storefs->reconfigurefunc = storeHashDirReconfigure;
+    storefs->donefunc = storeHashDirDone;
+    hash_state_pool = memPoolCreate("HASH IO State data", sizeof(hashstate_t));
+    hash_initialised = 1;
+}
Index: squid/src/fs/hash/store_hash.h
diff -u /dev/null squid/src/fs/hash/store_hash.h:1.1.2.4
--- /dev/null	Sun Jan 25 06:37:04 2004
+++ squid/src/fs/hash/store_hash.h	Sat Jan  6 06:35:57 2001
@@ -0,0 +1,48 @@
+/*
+ * store_hash.h
+ *
+ * Internal declarations for the hash routines
+ */
+
+#ifndef __STORE_HASH_H__
+#define __STORE_HASH_H__
+
+struct _hashinfo_t {
+    int swaplog_fd;
+    fileMap *map;
+    int suggest;
+};
+
+struct _hashstate_t {
+    int fd;
+    struct {
+	unsigned int close_request:1;
+	unsigned int reading:1;
+	unsigned int writing:1;
+    } flags;
+};
+
+typedef struct _hashinfo_t hashinfo_t;
+typedef struct _hashstate_t hashstate_t;
+
+/* The hash_state memory pool */
+extern MemPool *hash_state_pool;
+
+extern void storeHashDirMapBitReset(SwapDir *, sfileno);
+extern int storeHashDirMapBitAllocate(SwapDir *);
+extern char *storeHashDirFullPath(SwapDir * SD, const char *uri, 
+  const method_t method, char *fullpath);
+extern void storeHashDirUnlinkFile(SwapDir *, sfileno);
+extern void storeHashDirReplAdd(SwapDir * SD, StoreEntry *);
+extern void storeHashDirReplRemove(StoreEntry *);
+
+/*
+ * Store IO stuff
+ */
+extern STOBJGET storeHashGet;
+extern STOBJCLOSE storeHashClose;
+extern STOBJREAD storeHashRead;
+extern STOBJWRITE storeHashWrite;
+extern STOBJUNLINK storeHashUnlink;
+
+#endif
